diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/network/utils/radiotap-header.h ns-3.44/src/network/utils/radiotap-header.h
--- ns-3.43/src/network/utils/radiotap-header.h	2024-10-09 16:41:10.076656600 -0700
+++ ns-3.44/src/network/utils/radiotap-header.h	2025-03-09 16:55:49.679372300 -0700
@@ -10,7 +10,11 @@
 #ifndef RADIOTAP_HEADER_H
 #define RADIOTAP_HEADER_H
 
-#include <ns3/header.h>
+#include "ns3/header.h"
+
+#include <array>
+#include <optional>
+#include <vector>
 
 namespace ns3
 {
@@ -58,8 +62,7 @@
      * byte buffer of a packet.  The data read is expected to match bit-for-bit
      * the representation of this header in real networks.
      *
-     * @param start An iterator which points to where the header should
-     *              written.
+     * @param start An iterator which points to where the header should be read.
      * @returns The number of bytes read.
      */
     uint32_t Deserialize(Buffer::Iterator start) override;
@@ -92,7 +95,7 @@
     /**
      * @brief Frame flags.
      */
-    enum FrameFlag
+    enum FrameFlag : uint8_t
     {
         FRAME_FLAG_NONE = 0x00,           /**< No flags set */
         FRAME_FLAG_CFP = 0x01,            /**< Frame sent/received during CFP */
@@ -121,7 +124,7 @@
     /**
      * @brief Channel flags.
      */
-    enum ChannelFlags
+    enum ChannelFlags : uint16_t
     {
         CHANNEL_FLAG_NONE = 0x0000,          /**< No flags set */
         CHANNEL_FLAG_TURBO = 0x0010,         /**< Turbo Channel */
@@ -135,12 +138,20 @@
     };
 
     /**
-     * @brief Set the transmit/receive channel frequency and flags
-     * @param frequency The transmit/receive data rate in units of 500 kbps.
-     * @param flags The flags to set.
-     * @see ChannelFlags
+     * structure that contains the subfields of the Channel field.
      */
-    void SetChannelFrequencyAndFlags(uint16_t frequency, uint16_t flags);
+    struct ChannelFields
+    {
+        uint16_t frequency{0};             //!< Tx/Rx frequency in MHz
+        uint16_t flags{CHANNEL_FLAG_NONE}; //!< flags field (@see ChannelFlags)
+    };
+
+    /**
+     * @brief Set the subfields of the Channel field
+     *
+     * @param channelFields The subfields of the Channel field.
+     */
+    void SetChannelFields(const ChannelFields& channelFields);
 
     /**
      * @brief Set the RF signal power at the antenna as a decibel difference
@@ -163,7 +174,7 @@
     /**
      * @brief MCS known bits.
      */
-    enum McsKnown
+    enum McsKnown : uint8_t
     {
         MCS_KNOWN_NONE = 0x00,           /**< No flags set */
         MCS_KNOWN_BANDWIDTH = 0x01,      /**< Bandwidth */
@@ -180,7 +191,7 @@
     /**
      * @brief MCS flags.
      */
-    enum McsFlags
+    enum McsFlags : uint8_t
     {
         MCS_FLAGS_NONE =
             0x00, /**< Default: 20 MHz, long guard interval, mixed HT format and BCC FEC type */
@@ -196,18 +207,26 @@
     };
 
     /**
-     * @brief Set the MCS fields
+     * structure that contains the subfields of the MCS field.
+     */
+    struct McsFields
+    {
+        uint8_t known{MCS_KNOWN_NONE}; //!< known flags
+        uint8_t flags{MCS_FLAGS_NONE}; //!< flags field
+        uint8_t mcs{0};                //!< MCS index value
+    };
+
+    /**
+     * @brief Set the subfields of the MCS field
      *
-     * @param known The kwown flags.
-     * @param flags The flags to set.
-     * @param mcs The MCS index value.
+     * @param mcsFields The subfields of the MCS field.
      */
-    void SetMcsFields(uint8_t known, uint8_t flags, uint8_t mcs);
+    void SetMcsFields(const McsFields& mcsFields);
 
     /**
      * @brief A-MPDU status flags.
      */
-    enum AmpduFlags
+    enum AmpduFlags : uint8_t
     {
         A_MPDU_STATUS_NONE = 0x00,               /**< No flags set */
         A_MPDU_STATUS_REPORT_ZERO_LENGTH = 0x01, /**< Driver reports 0-length subframes */
@@ -222,19 +241,28 @@
     };
 
     /**
-     * @brief Set the A-MPDU status fields
+     * structure that contains the subfields of the A-MPDU status field.
+     */
+    struct AmpduStatusFields
+    {
+        uint32_t referenceNumber{
+            0}; //!< A-MPDU reference number to identify all subframes belonging to the same A-MPDU
+        uint16_t flags{A_MPDU_STATUS_NONE}; //!< flags field
+        uint8_t crc{1};                     //!< CRC field
+        uint8_t reserved{0};                //!< Reserved field
+    };
+
+    /**
+     * @brief Set the subfields of the A-MPDU status field
      *
-     * @param referenceNumber The A-MPDU reference number to identify all subframes belonging to the
-     * same A-MPDU.
-     * @param flags The flags to set.
-     * @param crc The CRC value value.
+     * @param ampduStatusFields The subfields of the A-MPDU status field.
      */
-    void SetAmpduStatus(uint32_t referenceNumber, uint16_t flags, uint8_t crc);
+    void SetAmpduStatus(const AmpduStatusFields& ampduStatusFields);
 
     /**
      * @brief VHT known bits.
      */
-    enum VhtKnown
+    enum VhtKnown : uint16_t
     {
         VHT_KNOWN_NONE = 0x0000, /**< No flags set */
         VHT_KNOWN_STBC = 0x0001, /**< Space-time block coding (1 if all spatial streams of all users
@@ -253,7 +281,7 @@
     /**
      * @brief VHT flags.
      */
-    enum VhtFlags
+    enum VhtFlags : uint8_t
     {
         VHT_FLAGS_NONE = 0x00, /**< No flags set */
         VHT_FLAGS_STBC =
@@ -270,29 +298,32 @@
     };
 
     /**
-     * @brief Set the VHT fields
+     * structure that contains the subfields of the VHT field.
+     */
+    struct VhtFields
+    {
+        uint16_t known{VHT_KNOWN_NONE};  //!< known flags field
+        uint8_t flags{VHT_FLAGS_NONE};   //!< flags field
+        uint8_t bandwidth{0};            //!< bandwidth field
+        std::array<uint8_t, 4> mcsNss{}; //!< mcs_nss field
+        uint8_t coding{0};               //!< coding field
+        uint8_t groupId{0};              //!< group_id field
+        uint16_t partialAid{0};          //!< partial_aid field
+    };
+
+    /**
+     * @brief Set the subfields of the VHT field
      *
-     * @param known The kwown flags.
-     * @param flags The flags to set.
-     * @param bandwidth The bandwidth value.
-     * @param mcs_nss The mcs_nss value.
-     * @param coding The coding value.
-     * @param group_id The group_id value.
-     * @param partial_aid The partial_aid value.
-     */
-    void SetVhtFields(uint16_t known,
-                      uint8_t flags,
-                      uint8_t bandwidth,
-                      uint8_t mcs_nss[4],
-                      uint8_t coding,
-                      uint8_t group_id,
-                      uint16_t partial_aid);
+     * @param vhtFields The subfields of the VHT field.
+     */
+    void SetVhtFields(const VhtFields& vhtFields);
 
     /**
-     * @brief HE data1.
+     * @brief bits of the HE data fields.
      */
-    enum HeData1
+    enum HeData : uint16_t
     {
+        /* Data 1 */
         HE_DATA1_FORMAT_EXT_SU = 0x0001,      /**< HE EXT SU PPDU format */
         HE_DATA1_FORMAT_MU = 0x0002,          /**< HE MU PPDU format */
         HE_DATA1_FORMAT_TRIG = 0x0003,        /**< HE TRIG PPDU format */
@@ -312,13 +343,7 @@
         HE_DATA1_SPTL_REUSE4_KNOWN = 0x2000, /**< Spatial Reuse 4 known (HE TRIG PPDU format) */
         HE_DATA1_BW_RU_ALLOC_KNOWN = 0x4000, /**< data BW/RU allocation known */
         HE_DATA1_DOPPLER_KNOWN = 0x8000,     /**< Doppler known */
-    };
-
-    /**
-     * @brief HE data2.
-     */
-    enum HeData2
-    {
+        /* Data 2 */
         HE_DATA2_PRISEC_80_KNOWN = 0x0001,    /**< pri/sec 80 MHz known */
         HE_DATA2_GI_KNOWN = 0x0002,           /**< GI known */
         HE_DATA2_NUM_LTF_SYMS_KNOWN = 0x0004, /**< number of LTF symbols known */
@@ -330,13 +355,23 @@
         HE_DATA2_RU_OFFSET = 0x3f00,          /**< RU allocation offset */
         HE_DATA2_RU_OFFSET_KNOWN = 0x4000,    /**< RU allocation offset known */
         HE_DATA2_PRISEC_80_SEC = 0x8000,      /**< pri/sec 80 MHz */
-    };
-
-    /**
-     * @brief HE data5.
-     */
-    enum HeData5
-    {
+        /* Data 3 */
+        HE_DATA3_BSS_COLOR = 0x003f,
+        HE_DATA3_BEAM_CHANGE = 0x0040,
+        HE_DATA3_UL_DL = 0x0080,
+        HE_DATA3_DATA_MCS = 0x0f00,
+        HE_DATA3_DATA_DCM = 0x1000,
+        HE_DATA3_CODING = 0x2000,
+        HE_DATA3_LDPC_XSYMSEG = 0x4000,
+        HE_DATA3_STBC = 0x8000,
+        /* Data 4 */
+        HE_DATA4_SU_MU_SPTL_REUSE = 0x000f,
+        HE_DATA4_MU_STA_ID = 0x7ff0,
+        HE_DATA4_TB_SPTL_REUSE1 = 0x000f,
+        HE_DATA4_TB_SPTL_REUSE2 = 0x00f0,
+        HE_DATA4_TB_SPTL_REUSE3 = 0x0f00,
+        HE_DATA4_TB_SPTL_REUSE4 = 0xf000,
+        /* Data 5 */
         HE_DATA5_DATA_BW_RU_ALLOC_40MHZ = 0x0001,  /**< 40 MHz data Bandwidth */
         HE_DATA5_DATA_BW_RU_ALLOC_80MHZ = 0x0002,  /**< 80 MHz data Bandwidth */
         HE_DATA5_DATA_BW_RU_ALLOC_160MHZ = 0x0003, /**< 160 MHz data Bandwidth */
@@ -357,26 +392,29 @@
     };
 
     /**
-     * @brief Set the HE fields
+     * structure that contains the subfields of the HE field.
+     */
+    struct HeFields
+    {
+        uint16_t data1{0}; //!< data1 field
+        uint16_t data2{0}; //!< data2 field
+        uint16_t data3{0}; //!< data3 field
+        uint16_t data4{0}; //!< data4 field
+        uint16_t data5{0}; //!< data5 field
+        uint16_t data6{0}; //!< data6 field
+    };
+
+    /**
+     * @brief Set the subfields of the HE field
      *
-     * @param data1 The data1 field.
-     * @param data2 The data2 field.
-     * @param data3 The data3 field.
-     * @param data4 The data4 field.
-     * @param data5 The data5 field.
-     * @param data6 The data6 field.
-     */
-    void SetHeFields(uint16_t data1,
-                     uint16_t data2,
-                     uint16_t data3,
-                     uint16_t data4,
-                     uint16_t data5,
-                     uint16_t data6);
+     * @param heFields The subfields of the HE field.
+     */
+    void SetHeFields(const HeFields& heFields);
 
     /**
      * @brief HE MU flags1.
      */
-    enum HeMuFlags1
+    enum HeMuFlags1 : uint16_t
     {
         HE_MU_FLAGS1_SIGB_MCS = 0x000f,                //!< SIG-B MCS (from SIG-A)
         HE_MU_FLAGS1_SIGB_MCS_KNOWN = 0x0010,          //!< SIG-B MCS known
@@ -394,7 +432,7 @@
     /**
      * @brief HE MU flags2.
      */
-    enum HeMuFlags2
+    enum HeMuFlags2 : uint16_t
     {
         HE_MU_FLAGS2_BW_FROM_SIGA = 0x0003, /**< Bandwidth from Bandwidth field in HE-SIG-A */
         HE_MU_FLAGS2_BW_FROM_SIGA_KNOWN =
@@ -410,22 +448,27 @@
     };
 
     /**
-     * @brief Set the HE MU fields
+     * structure that contains the subfields of the HE-MU field.
+     */
+    struct HeMuFields
+    {
+        uint16_t flags1{0};                  //!< flags1 field
+        uint16_t flags2{0};                  //!< flags2 field
+        std::array<uint8_t, 4> ruChannel1{}; //!< RU_channel1 field
+        std::array<uint8_t, 4> ruChannel2{}; //!< RU_channel2 field
+    };
+
+    /**
+     * @brief Set the subfields of the HE-MU field
      *
-     * @param flags1 The flags1 field.
-     * @param flags2 The flags2 field.
-     * @param ruChannel1 The RU_channel1 field.
-     * @param ruChannel2 The RU_channel2 field.
-     */
-    void SetHeMuFields(uint16_t flags1,
-                       uint16_t flags2,
-                       const std::array<uint8_t, 4>& ruChannel1,
-                       const std::array<uint8_t, 4>& ruChannel2);
+     * @param heMuFields The subfields of the HE-MU field.
+     */
+    void SetHeMuFields(const HeMuFields& heMuFields);
 
     /**
      * @brief HE MU per_user_known.
      */
-    enum HeMuPerUserKnown
+    enum HeMuPerUserKnown : uint8_t
     {
         HE_MU_PER_USER_POSITION_KNOWN = 0x01,              //!< User field position known
         HE_MU_PER_USER_STA_ID_KNOWN = 0x02,                //!< STA-ID known
@@ -438,23 +481,518 @@
     };
 
     /**
-     * @brief Set the HE MU per user fields
+     * structure that contains the subfields of the HE-MU-other-user field.
+     */
+    struct HeMuOtherUserFields
+    {
+        uint16_t perUser1{0};       //!< per_user_1 field
+        uint16_t perUser2{0};       //!< per_user_2 field
+        uint8_t perUserPosition{0}; //!< per_user_position field
+        uint8_t perUserKnown{0};    //!< per_user_known field
+    };
+
+    /**
+     * @brief Set the subfields of the HE-MU-other-user field
      *
-     * @param perUser1 The per_user_1 field.
-     * @param perUser2 The per_user_2 field.
-     * @param perUserPosition The per_user_position field.
-     * @param perUserKnown The per_user_known field.
-     */
-    void SetHeMuPerUserFields(uint16_t perUser1,
-                              uint16_t perUser2,
-                              uint8_t perUserPosition,
-                              uint8_t perUserKnown);
+     * @param heMuOtherUserFields The subfields of the HE-MU-other-user field.
+     */
+    void SetHeMuOtherUserFields(const HeMuOtherUserFields& heMuOtherUserFields);
+
+    /**
+     * structure that contains the subfields of the TLV fields.
+     */
+    struct TlvFields
+    {
+        uint16_t type{0};   //!< type field.
+        uint16_t length{0}; //!< length field.
+    };
+
+    /**
+     * structure that contains the subfields of the U-SIG field.
+     */
+    struct UsigFields
+    {
+        uint32_t common{0}; //!< common field.
+        uint32_t value{0};  //!< value field.
+        uint32_t mask{0};   //!< mask field.
+    };
+
+    /**
+     * @brief U-SIG common subfield.
+     */
+    enum UsigCommon : uint32_t
+    {
+        USIG_COMMON_PHY_VER_KNOWN = 0x00000001,
+        USIG_COMMON_BW_KNOWN = 0x00000002,
+        USIG_COMMON_UL_DL_KNOWN = 0x00000004,
+        USIG_COMMON_BSS_COLOR_KNOWN = 0x00000008,
+        USIG_COMMON_TXOP_KNOWN = 0x00000010,
+        USIG_COMMON_BAD_USIG_CRC = 0x00000020,
+        USIG_COMMON_VALIDATE_BITS_CHECKED = 0x00000040,
+        USIG_COMMON_VALIDATE_BITS_OK = 0x00000080,
+        USIG_COMMON_PHY_VER = 0x00007000,
+        USIG_COMMON_BW = 0x00038000,
+        USIG_COMMON_UL_DL = 0x00040000,
+        USIG_COMMON_BSS_COLOR = 0x01f80000,
+        USIG_COMMON_TXOP = 0xfe000000,
+    };
+
+    /**
+     * @brief Possible BW values in U-SIG common subfield.
+     */
+    enum UsigCommonBw : uint8_t
+    {
+        USIG_COMMON_BW_20MHZ = 0,
+        USIG_COMMON_BW_40MHZ = 1,
+        USIG_COMMON_BW_80MHZ = 2,
+        USIG_COMMON_BW_160MHZ = 3,
+        USIG_COMMON_BW_320MHZ_1 = 4,
+        USIG_COMMON_BW_320MHZ_2 = 5,
+    };
+
+    /**
+     * @brief EHT MU PPDU U-SIG contents.
+     */
+    enum UsigMu : uint32_t
+    {
+        /* MU-USIG-1 */
+        USIG1_MU_B20_B24_DISREGARD = 0x0000001f,
+        USIG1_MU_B25_VALIDATE = 0x00000020,
+        /* MU-USIG-2 */
+        USIG2_MU_B0_B1_PPDU_TYPE = 0x000000c0,
+        USIG2_MU_B2_VALIDATE = 0x00000100,
+        USIG2_MU_B3_B7_PUNCTURED_INFO = 0x00003e00,
+        USIG2_MU_B8_VALIDATE = 0x00004000,
+        USIG2_MU_B9_B10_SIG_MCS = 0x00018000,
+        USIG2_MU_B11_B15_EHT_SYMBOLS = 0x003e0000,
+        USIG2_MU_B16_B19_CRC = 0x03c00000,
+        USIG2_MU_B20_B25_TAIL = 0xfc000000,
+    };
+
+    /**
+     * @brief EHT TB PPDU U-SIG contents.
+     */
+    enum UsigTb : uint32_t
+    {
+        /* TB-USIG-1 */
+        USIG1_TB_B20_B25_DISREGARD = 0x0000001f,
+        /* TB-USIG-2 */
+        USIG2_TB_B0_B1_PPDU_TYPE = 0x000000c0,
+        USIG2_TB_B2_VALIDATE = 0x00000100,
+        USIG2_TB_B3_B6_SPATIAL_REUSE_1 = 0x00001e00,
+        USIG2_TB_B7_B10_SPATIAL_REUSE_2 = 0x0001e000,
+        USIG2_TB_B11_B15_DISREGARD = 0x003e0000,
+        USIG2_TB_B16_B19_CRC = 0x03c00000,
+        USIG2_TB_B20_B25_TAIL = 0xfc000000,
+    };
+
+    /**
+     * @brief Set the subfields of the U-SIG field
+     *
+     * @param usigFields The subfields of the U-SIG field.
+     */
+    void SetUsigFields(const UsigFields& usigFields);
+
+    /**
+     * structure that contains the subfields of the EHT field.
+     */
+    struct EhtFields
+    {
+        uint32_t known{0};                //!< known field.
+        std::array<uint32_t, 9> data{};   //!< data fields.
+        std::vector<uint32_t> userInfo{}; //!< user info fields.
+    };
+
+    /**
+     * @brief EHT known subfield.
+     */
+    enum EhtKnown : uint32_t
+    {
+        EHT_KNOWN_SPATIAL_REUSE = 0x00000002,
+        EHT_KNOWN_GI = 0x00000004,
+        EHT_KNOWN_EHT_LTF = 0x00000010,
+        EHT_KNOWN_LDPC_EXTRA_SYM_OM = 0x00000020,
+        EHT_KNOWN_PRE_PADD_FACOR_OM = 0x00000040,
+        EHT_KNOWN_PE_DISAMBIGUITY_OM = 0x00000080,
+        EHT_KNOWN_DISREGARD_O = 0x00000100,
+        EHT_KNOWN_DISREGARD_S = 0x00000200,
+        EHT_KNOWN_CRC1 = 0x00002000,
+        EHT_KNOWN_TAIL1 = 0x00004000,
+        EHT_KNOWN_CRC2_O = 0x00008000,
+        EHT_KNOWN_TAIL2_O = 0x00010000,
+        EHT_KNOWN_NSS_S = 0x00020000,
+        EHT_KNOWN_BEAMFORMED_S = 0x00040000,
+        EHT_KNOWN_NR_NON_OFDMA_USERS_M = 0x00080000,
+        EHT_KNOWN_ENCODING_BLOCK_CRC_M = 0x00100000,
+        EHT_KNOWN_ENCODING_BLOCK_TAIL_M = 0x00200000,
+        EHT_KNOWN_RU_MRU_SIZE_OM = 0x00400000,
+        EHT_KNOWN_RU_MRU_INDEX_OM = 0x00800000,
+        EHT_KNOWN_RU_ALLOC_TB_OM = 0x01000000,
+        EHT_KNOWN_PRIMARY_80 = 0x02000000,
+    };
+
+    /**
+     * @brief EHT data subfield.
+     */
+    enum EhtData : uint32_t
+    {
+        /* Data 0 */
+        EHT_DATA0_SPATIAL_REUSE = 0x00000078,
+        EHT_DATA0_GI = 0x00000180,
+        EHT_DATA0_LTF = 0x00000600,
+        EHT_DATA0_EHT_LTF = 0x00003800,
+        EHT_DATA0_LDPC_EXTRA_SYM_OM = 0x00004000,
+        EHT_DATA0_PRE_PADD_FACOR_OM = 0x00018000,
+        EHT_DATA0_PE_DISAMBIGUITY_OM = 0x00020000,
+        EHT_DATA0_DISREGARD_S = 0x000c0000,
+        EHT_DATA0_DISREGARD_O = 0x003c0000,
+        EHT_DATA0_CRC1_O = 0x03c00000,
+        EHT_DATA0_TAIL1_O = 0xfc000000,
+        /* Data 1 */
+        EHT_DATA1_RU_MRU_SIZE = 0x0000001f,
+        EHT_DATA1_RU_MRU_INDEX = 0x00001fe0,
+        EHT_DATA1_RU_ALLOC_CC_1_1_1 = 0x003fe000,
+        EHT_DATA1_RU_ALLOC_CC_1_1_1_KNOWN = 0x00400000,
+        EHT_DATA1_PRIMARY_80 = 0xc0000000,
+        /* Data 2 */
+        EHT_DATA2_RU_ALLOC_CC_2_1_1 = 0x000001ff,
+        EHT_DATA2_RU_ALLOC_CC_2_1_1_KNOWN = 0x00000200,
+        EHT_DATA2_RU_ALLOC_CC_1_1_2 = 0x0007fc00,
+        EHT_DATA2_RU_ALLOC_CC_1_1_2_KNOWN = 0x00080000,
+        EHT_DATA2_RU_ALLOC_CC_2_1_2 = 0x1ff00000,
+        EHT_DATA2_RU_ALLOC_CC_2_1_2_KNOWN = 0x20000000,
+        /* Data 3 */
+        EHT_DATA3_RU_ALLOC_CC_1_2_1 = 0x000001ff,
+        EHT_DATA3_RU_ALLOC_CC_1_2_1_KNOWN = 0x00000200,
+        EHT_DATA3_RU_ALLOC_CC_2_2_1 = 0x0007fc00,
+        EHT_DATA3_RU_ALLOC_CC_2_2_1_KNOWN = 0x00080000,
+        EHT_DATA3_RU_ALLOC_CC_1_2_2 = 0x1ff00000,
+        EHT_DATA3_RU_ALLOC_CC_1_2_2_KNOWN = 0x20000000,
+        /* Data 4 */
+        EHT_DATA4_RU_ALLOC_CC_2_2_2 = 0x000001ff,
+        EHT_DATA4_RU_ALLOC_CC_2_2_2_KNOWN = 0x00000200,
+        EHT_DATA4_RU_ALLOC_CC_1_2_3 = 0x0007fc00,
+        EHT_DATA4_RU_ALLOC_CC_1_2_3_KNOWN = 0x00080000,
+        EHT_DATA4_RU_ALLOC_CC_2_2_3 = 0x1ff00000,
+        EHT_DATA4_RU_ALLOC_CC_2_2_3_KNOWN = 0x20000000,
+        /* Data 5 */
+        EHT_DATA5_RU_ALLOC_CC_1_2_4 = 0x000001ff,
+        EHT_DATA5_RU_ALLOC_CC_1_2_4_KNOWN = 0x00000200,
+        EHT_DATA5_RU_ALLOC_CC_2_2_4 = 0x0007fc00,
+        EHT_DATA5_RU_ALLOC_CC_2_2_4_KNOWN = 0x00080000,
+        EHT_DATA5_RU_ALLOC_CC_1_2_5 = 0x1ff00000,
+        EHT_DATA5_RU_ALLOC_CC_1_2_5_KNOWN = 0x20000000,
+        /* Data 6 */
+        EHT_DATA6_RU_ALLOC_CC_2_2_5 = 0x000001ff,
+        EHT_DATA6_RU_ALLOC_CC_2_2_5_KNOWN = 0x00000200,
+        EHT_DATA6_RU_ALLOC_CC_1_2_6 = 0x0007fc00,
+        EHT_DATA6_RU_ALLOC_CC_1_2_6_KNOWN = 0x00080000,
+        EHT_DATA6_RU_ALLOC_CC_2_2_6 = 0x1ff00000,
+        EHT_DATA6_RU_ALLOC_CC_2_2_6_KNOWN = 0x20000000,
+        /* Data 7 */
+        EHT_DATA7_CRC2_O = 0x0000000f,
+        EHT_DATA7_TAIL_2_O = 0x000003f0,
+        EHT_DATA7_NSS_S = 0x0000f000,
+        EHT_DATA7_BEAMFORMED_S = 0x00010000,
+        EHT_DATA7_NUM_OF_NON_OFDMA_USERS = 0x000e0000,
+        EHT_DATA7_USER_ENCODING_BLOCK_CRC = 0x00f00000,
+        EHT_DATA7_USER_ENCODING_BLOCK_TAIL = 0x3f000000,
+        /* Data 8 */
+        EHT_DATA8_RU_ALLOC_TB_FMT_PS_160 = 0x00000001,
+        EHT_DATA8_RU_ALLOC_TB_FMT_B0 = 0x00000002,
+        EHT_DATA8_RU_ALLOC_TB_FMT_B7_B1 = 0x000001fc,
+    };
+
+    /**
+     * @brief Possible GI values in EHT data subfield.
+     */
+    enum EhtData0Gi : uint8_t
+    {
+        EHT_DATA0_GI_800_NS = 0,
+        EHT_DATA0_GI_1600_NS = 1,
+        EHT_DATA0_GI_3200_NS = 2,
+    };
+
+    /**
+     * @brief Possible Primary 80 MHz Channel Position values in EHT data subfield.
+     */
+    enum EhtData1Primary80 : uint8_t
+    {
+        EHT_DATA1_PRIMARY_80_LOWEST = 0,
+        EHT_DATA1_PRIMARY_80_HIGHEST = 3,
+    };
+
+    /**
+     * @brief Possible RU/MRU Size values in EHT data subfield.
+     */
+    enum EhtData1RuSize : uint8_t
+    {
+        EHT_DATA1_RU_MRU_SIZE_26 = 0,
+        EHT_DATA1_RU_MRU_SIZE_52 = 1,
+        EHT_DATA1_RU_MRU_SIZE_106 = 2,
+        EHT_DATA1_RU_MRU_SIZE_242 = 3,
+        EHT_DATA1_RU_MRU_SIZE_484 = 4,
+        EHT_DATA1_RU_MRU_SIZE_996 = 5,
+        EHT_DATA1_RU_MRU_SIZE_2x996 = 6,
+        EHT_DATA1_RU_MRU_SIZE_4x996 = 7,
+        EHT_DATA1_RU_MRU_SIZE_52_26 = 8,
+        EHT_DATA1_RU_MRU_SIZE_106_26 = 9,
+        EHT_DATA1_RU_MRU_SIZE_484_242 = 10,
+        EHT_DATA1_RU_MRU_SIZE_996_484 = 11,
+        EHT_DATA1_RU_MRU_SIZE_996_484_242 = 12,
+        EHT_DATA1_RU_MRU_SIZE_2x996_484 = 13,
+        EHT_DATA1_RU_MRU_SIZE_3x996 = 14,
+        EHT_DATA1_RU_MRU_SIZE_3x996_484 = 15,
+    };
+
+    /**
+     * @brief EHT user_info subfield.
+     */
+    enum EhtUserInfo : uint32_t
+    {
+        EHT_USER_INFO_STA_ID_KNOWN = 0x00000001,
+        EHT_USER_INFO_MCS_KNOWN = 0x00000002,
+        EHT_USER_INFO_CODING_KNOWN = 0x00000004,
+        EHT_USER_INFO_NSS_KNOWN_O = 0x00000010,
+        EHT_USER_INFO_BEAMFORMING_KNOWN_O = 0x00000020,
+        EHT_USER_INFO_SPATIAL_CONFIG_KNOWN_M = 0x00000040,
+        EHT_USER_INFO_DATA_FOR_USER = 0x00000080,
+        EHT_USER_INFO_STA_ID = 0x0007ff00,
+        EHT_USER_INFO_CODING = 0x00080000,
+        EHT_USER_INFO_MCS = 0x00f00000,
+        EHT_USER_INFO_NSS_O = 0x0f000000,
+        EHT_USER_INFO_BEAMFORMING_O = 0x20000000,
+        EHT_USER_INFO_SPATIAL_CONFIG_M = 0x3f000000,
+    };
+
+    /**
+     * @brief Set the subfields of the EHT-SIG field
+     *
+     * @param ehtFields The subfields of the EHT-SIG field.
+     */
+    void SetEhtFields(const EhtFields& ehtFields);
 
   private:
     /**
+     * Serialize the Channel radiotap header.
+     *
+     * @param start An iterator which points to where the header should be written.
+     */
+    void SerializeChannel(Buffer::Iterator& start) const;
+
+    /**
+     * Deserialize the Channel radiotap header.
+     *
+     * @param start An iterator which points to where the header should be read.
+     * @param bytesRead the number of bytes already read.
+
+     * @returns The number of bytes read.
+     */
+    uint32_t DeserializeChannel(Buffer::Iterator start, uint32_t bytesRead);
+
+    /**
+     * Add Channel subfield/value pairs to the output stream.
+     *
+     * @param os The output stream
+     */
+    void PrintChannel(std::ostream& os) const;
+
+    /**
+     * Serialize the MCS radiotap header.
+     *
+     * @param start An iterator which points to where the header should be written.
+     */
+    void SerializeMcs(Buffer::Iterator& start) const;
+
+    /**
+     * Deserialize the MCS radiotap header.
+     *
+     * @param start An iterator which points to where the header should be read.
+     * @param bytesRead the number of bytes already read.
+
+     * @returns The number of bytes read.
+     */
+    uint32_t DeserializeMcs(Buffer::Iterator start, uint32_t bytesRead);
+
+    /**
+     * Add MCS subfield/value pairs to the output stream.
+     *
+     * @param os The output stream
+     */
+    void PrintMcs(std::ostream& os) const;
+
+    /**
+     * Serialize the A-MPDU Status radiotap header.
+     *
+     * @param start An iterator which points to where the header should be written.
+     */
+    void SerializeAmpduStatus(Buffer::Iterator& start) const;
+
+    /**
+     * Deserialize the A-MPDU Status radiotap header.
+     *
+     * @param start An iterator which points to where the header should be read.
+     * @param bytesRead the number of bytes already read.
+
+     * @returns The number of bytes read.
+     */
+    uint32_t DeserializeAmpduStatus(Buffer::Iterator start, uint32_t bytesRead);
+
+    /**
+     * Add A-MPDU Status subfield/value pairs to the output stream.
+     *
+     * @param os The output stream
+     */
+    void PrintAmpduStatus(std::ostream& os) const;
+
+    /**
+     * Serialize the VHT radiotap header.
+     *
+     * @param start An iterator which points to where the header should be written.
+     */
+    void SerializeVht(Buffer::Iterator& start) const;
+
+    /**
+     * Deserialize the VHT radiotap header.
+     *
+     * @param start An iterator which points to where the header should be read.
+     * @param bytesRead the number of bytes already read.
+
+     * @returns The number of bytes read.
+     */
+    uint32_t DeserializeVht(Buffer::Iterator start, uint32_t bytesRead);
+
+    /**
+     * Add VHT subfield/value pairs to the output stream.
+     *
+     * @param os The output stream
+     */
+    void PrintVht(std::ostream& os) const;
+
+    /**
+     * Serialize the HE radiotap header.
+     *
+     * @param start An iterator which points to where the header should be written.
+     */
+    void SerializeHe(Buffer::Iterator& start) const;
+
+    /**
+     * Deserialize the HE radiotap header.
+     *
+     * @param start An iterator which points to where the header should be read.
+     * @param bytesRead the number of bytes already read.
+
+     * @returns The number of bytes read.
+     */
+    uint32_t DeserializeHe(Buffer::Iterator start, uint32_t bytesRead);
+
+    /**
+     * Add HE subfield/value pairs to the output stream.
+     *
+     * @param os The output stream
+     */
+    void PrintHe(std::ostream& os) const;
+
+    /**
+     * Serialize the HE-MU radiotap header.
+     *
+     * @param start An iterator which points to where the header should be written.
+     */
+    void SerializeHeMu(Buffer::Iterator& start) const;
+
+    /**
+     * Deserialize the HE-MU radiotap header.
+     *
+     * @param start An iterator which points to where the header should be read.
+     * @param bytesRead the number of bytes already read.
+
+     * @returns The number of bytes read.
+     */
+    uint32_t DeserializeHeMu(Buffer::Iterator start, uint32_t bytesRead);
+
+    /**
+     * Add HE-MU subfield/value pairs to the output stream.
+     *
+     * @param os The output stream
+     */
+    void PrintHeMu(std::ostream& os) const;
+
+    /**
+     * Serialize the HE-MU-other-user radiotap header.
+     *
+     * @param start An iterator which points to where the header should be written.
+     */
+    void SerializeHeMuOtherUser(Buffer::Iterator& start) const;
+
+    /**
+     * Deserialize the HE-MU-other-user radiotap header.
+     *
+     * @param start An iterator which points to where the header should be read.
+     * @param bytesRead the number of bytes already read.
+
+     * @returns The number of bytes read.
+     */
+    uint32_t DeserializeHeMuOtherUser(Buffer::Iterator start, uint32_t bytesRead);
+
+    /**
+     * Add HE-MU-other-user subfield/value pairs to the output stream.
+     *
+     * @param os The output stream
+     */
+    void PrintHeMuOtherUser(std::ostream& os) const;
+
+    /**
+     * Serialize the U-SIG radiotap header.
+     *
+     * @param start An iterator which points to where the header should be written.
+     */
+    void SerializeUsig(Buffer::Iterator& start) const;
+
+    /**
+     * Deserialize the U-SIG radiotap header.
+     *
+     * @param start An iterator which points to where the header should be read.
+     * @param bytesRead the number of bytes already read.
+
+     * @returns The number of bytes read.
+     */
+    uint32_t DeserializeUsig(Buffer::Iterator start, uint32_t bytesRead);
+
+    /**
+     * Add U-SIG subfield/value pairs to the output stream.
+     *
+     * @param os The output stream
+     */
+    void PrintUsig(std::ostream& os) const;
+
+    /**
+     * Serialize the EHT radiotap header.
+     *
+     * @param start An iterator which points to where the header should be written.
+     */
+    void SerializeEht(Buffer::Iterator& start) const;
+
+    /**
+     * Deserialize the EHT radiotap header.
+     *
+     * @param start An iterator which points to where the header should be read.
+     * @param bytesRead the number of bytes already read.
+
+     * @returns The number of bytes read.
+     */
+    uint32_t DeserializeEht(Buffer::Iterator start, uint32_t bytesRead);
+
+    /**
+     * Add EHT subfield/value pairs to the output stream.
+     *
+     * @param os The output stream
+     */
+    void PrintEht(std::ostream& os) const;
+
+    /**
      * @brief Radiotap flags.
      */
-    enum RadiotapFlags
+    enum RadiotapFlags : uint32_t
     {
         RADIOTAP_TSFT = 0x00000001,
         RADIOTAP_FLAGS = 0x00000002,
